#include <Stepper.h>
#include<Servo.h>

Servo s1;
const int stepsPerRevolution = 2048;
Stepper stepperName(stepsPerRevolution, 8, 10, 9, 11);
const int trigPin = 5;
const int echoPin = 6;

void setup() {
  pinMode(0, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  stepperName.setSpeed(7);
  s1.attach(7);
  s1.write(150);
  Serial.begin(9600);
}

void loop() {
  updateUltrasonic();
  delay(1000);
  int dist = distanta();
  Serial.println(dist);

  if(dist < 5){
  if (digitalRead(0) == LOW) {
    Serial.println("Butonul 0 apăsat");
    stepperName.step(6.2 * stepsPerRevolution);
    rotateServo();
    delay(500);
    
    updateUltrasonic();
  }else if(digitalRead(3) == LOW)
  {
    stepperName.step(11.35 * stepsPerRevolution);
    rotateServo()
    delay(500);
  }

  }else if(dist >= 15 && dist <= 20)
  {
    if (digitalRead(3) == LOW) {
    Serial.println("Butonul 2 apăsat");
    stepperName.step(5 * stepsPerRevolution);
    rotateServo()
    delay(500);
    
    updateUltrasonic();
  }else if (digitalRead(4) == LOW) {
    Serial.println("Butonul 1 apăsat");
    stepperName.step(-6.2 * stepsPerRevolution);
    rotateServo()
    delay(500);
    
    updateUltrasonic();
  }
  }else if(dist > 25)
  {
    if (digitalRead(0) == LOW) {
    Serial.println("Butonul 2 apăsat");
    stepperName.step(-5 * stepsPerRevolution);
    rotateServo()
    delay(500);
    
    updateUltrasonic();
  }else if (digitalRead(4) == LOW) {
    Serial.println("Butonul 2 apăsat");
    stepperName.step(-11.35 * stepsPerRevolution);
    rotateServo()
    delay(500);
    
    updateUltrasonic();
  

  
}
  }
}
void updateUltrasonic() {
  long duration, inches, cm;

  pinMode(trigPin, OUTPUT);
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);
  cm = microsecondsToCentimeters(duration);

  Serial.print("Distanța: ");
  Serial.print(cm);
  Serial.println(" cm");
}

int distanta() {
  long duration, inches, cm;

  pinMode(trigPin, OUTPUT);
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);
  cm = microsecondsToCentimeters(duration);

  Serial.print("Distanța: ");
  Serial.print(cm);
  Serial.println(" cm");
  return cm;
}

long microsecondsToInches(long microseconds) {
  return microseconds / 74 / 2;
}

long microsecondsToCentimeters(long microseconds) {
  return microseconds / 29 / 2;
}

void rotateServo() {
  for (int i = 140; i >= 0; i -= 1) {
    s1.write(i);
    delay(25);
  }

  delay(2000);

  for (int i = 0; i <= 140; i += 1) {
    s1.write(i);
    delay(25);
  }
}
